src/Entity/FormIO.php
<?php

namespace App\Entity;

use App\Form\Admin\Servizio\PaymentDataType;
use Doctrine\ORM\Mapping as ORM;

/**
 * Class FormIO
 * @ORM\Entity
 */
class FormIO extends Pratica implements DematerializedFormPratica
{


  const FIELD_SUBJECT = 'application_subject';

  /**
   * @ORM\Column(type="json", options={"jsonb":true})
   * @var array
   */
  protected $dematerializedForms;

  /**
   * SciaPraticaEdilizia constructor.
   */
  public function __construct()
  {
    parent::__construct();
    $this->type = self::TYPE_FORMIO;
    $this->dematerializedForms = [];
  }

  /**
   * @return array
   */
  public function getDematerializedForms()
  {
    return $this->dematerializedForms;
  }

  /**
   * @param $dematerializedForms
   * @return $this
   */
  public function setDematerializedForms($dematerializedForms)
  {
    $this->dematerializedForms = $dematerializedForms;

    return $this;
  }

  public function getPaymentAmount()
  {

    // Recupero l'importo dal form
    if (isset($this->dematerializedForms['flattened'][PaymentDataType::PAYMENT_AMOUNT]) && $this->dematerializedForms['flattened'][PaymentDataType::PAYMENT_AMOUNT]) {
      return str_replace(',', '.', $this->dematerializedForms['flattened'][PaymentDataType::PAYMENT_AMOUNT]);
    }
    // Recupero l'importo dal servizio
    if (isset($this->getServizio()->getPaymentParameters()['total_amounts'])) {
      return str_replace(',', '.', $this->getServizio()->getPaymentParameters()['total_amounts']);
    }

    return 0;
  }

  public function setPaymentAmount($amount)
  {
    $dematerializedForms = $this->dematerializedForms;
    $dematerializedForms['data'][PaymentDataType::PAYMENT_AMOUNT] = $amount;
    $dematerializedForms['flattened'][PaymentDataType::PAYMENT_AMOUNT] = $amount;
    $this->dematerializedForms = $dematerializedForms;
  }

  public function isPaymentExempt()
  {
    $data = $this->dematerializedForms;
    return isset($data['flattened'][PaymentDataType::PAYMENT_AMOUNT]) && $data['flattened'][PaymentDataType::PAYMENT_AMOUNT] <= 0;
  }

  public function hasPaymentDeferred()
  {
    if ($this->getPaymentAmount() > 0) {
      $paymentData = $this->getPaymentData();
      return isset($paymentData['deferred']) && $paymentData['deferred'];
    }
    return false;
  }

  public function getType(): string
  {
    return Pratica::TYPE_FORMIO;
  }

  public function generateSubject(): string
  {
    $data = $this->dematerializedForms;
    if (isset($data['flattened'][self::FIELD_SUBJECT]) && !empty($data['flattened'][self::FIELD_SUBJECT])) {
      return $data['flattened'][self::FIELD_SUBJECT] . ' - '. $this->getId();
    }
    return parent::generateSubject();
  }

}

templates/Pratiche/parts/landing/_f24.html.twig
{% block javascripts %}
  {{ encore_entry_script_tags('summary-f24') }}
{% endblock %}

{% block main_content %}
  <div class="cmp-heading pb-3 pb-lg-4">
    {# In attesa di generazione del pdf #}
    {% if pratica.status == 1900 %}
      <div class="categoryicon-top d-flex" id="container-f24" data-application="{{ pratica.id }}" data-url="{{ app.request.getSchemeAndHttpHost() ~ '/' ~ prefix}}">
        <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
          <use href="/bootstrap-italia/dist/svg/sprite.svg#it-check-circle"></use>
        </svg>
        <h1 class="title-xxxlarge">{{ 'pratica.f24_sent' | trans }}</h1>
      </div>
      <p class="my-2">
        {{ 'operatori.attesa_modello_f24_info'|trans|raw }}
      </p>
      <div class="alert alert-warning alert-error d-none" role="alert"></div>
      <button disabled type="button" class="btn btn-secondary btn-xs disabled fw-bold mb-2 d-flex align-items-center px-1 justify-content-center btn-f24-loader">
        <div class="progress-spinner progress-spinner-double size-sm progress-spinner-active">
          <div class="progress-spinner-inner"></div>
          <div class="progress-spinner-inner"></div>
        </div>
        <div class="px-2"><span>  {{ 'operatori.attesa_modulo_compilato_pdf'|trans|raw }}</span></div>
      </button>
      {# Pratica inviata #}
    {% elseif pratica.status == 2000 %}
      <div class="container">
        <div class="row">
          <div class="cmp-heading pb-3 pb-lg-4">
            <div class="categoryicon-top d-flex">
              <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
                <use href="{{ asset('bundles/app/images/sprites.svg') }}#it-check-circle"></use>
              </svg>
              <h1 class="title-xxxlarge">{{ 'pratica.f24_created' | trans }}</h1>
            </div>
            <p class="subtitle-small"> {{ 'pratica.thanks_message_f24'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id})|raw }}</p>
            <p class="pt-3 pt-lg-4 mb-0">{{ 'pratica.sent_to_email' | trans }}:<br/>
              <strong>{{ pratica.user.email }}</strong></p>
            {% set attachment = pratica.moduliCompilati|first %}
            <a class="btn btn-outline-primary fw-bold"
               href="{{ path('allegati_download', {'allegato': attachment.id}) }}" download>
                  <span class="rounded-icon">
                    <svg class="icon icon-primary icon-sm" aria-hidden="true">
                      <use href="{{ asset('bundles/app/images/sprites.svg') }}#it-download"></use>
                    </svg>
                  </span>
              <span>{{ 'operatori.download.f24' | trans }}</span>
            </a>
          </div>
        </div>

        {% if is_granted('ROLE_USER') and not is_granted('ROLE_OPERATORE') %}
          <p class="mt-4 mt-lg-3 mb-40 mb-lg-100">
            <a class="t-primary" href="{{ app.request.uri ~ '/detail' }}">{{ 'pratica.consulta_dati' | trans }}</a>
            {{ 'pratica.nella_tua_area_riservata' | trans }}.
          </p>
        {% endif %}
      </div>
    {% else %}
      {% set attachment = pratica.moduliCompilati|first %}
      <a class="btn btn-outline-primary fw-bold mt-3"
         href="{{ path('allegati_download', {'allegato': attachment.id}) }}" download>
                  <span class="rounded-icon">
                    <svg class="icon icon-primary icon-sm" aria-hidden="true">
                      <use href="/bootstrap-italia/dist/svg/sprite.svg#it-download"></use>
                    </svg>
                  </span>
        <span>{{ 'operatori.scarica_richiesta_protocollata'|trans }}</span>
      </a>
    {% endif %}
  </div>
{% endblock %}

templates/Pratiche/parts/landing/_general.html.twig
<div class="cmp-heading pb-3 pb-lg-4">

  <div class="categoryicon-top d-flex">
    <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
      <use href="/bootstrap-italia/dist/svg/sprite.svg#it-check-circle"></use>
    </svg>
    <h1 class="title-xxxlarge">{{ 'pratica.application_sent' | trans }}</h1>
  </div>

  <p class="subtitle-small">{{ 'pratica.thanks_message'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id,'%ente%':pratica.ente.name})|raw }}</p>

  {% if not pratica.servizio.disableMessageNotifications %}
    <p class="pb-2 mb-0">{{ 'pratica.sent_to_email' | trans }}:<br>
      <strong>{{ pratica.user.email }}</strong>
    </p>
  {% endif %}

</div>

templates/Pratiche/parts/landing/_payment.html.twig
<div class="cmp-heading pb-3 pb-lg-4">
  {% if app.request.query.get('payment') == 'ko' %}
    <div class="categoryicon-top d-flex">
      <svg class="icon icon-danger mr-10 big-lg-icon mb-1" aria-hidden="true">
        <use href="/bootstrap-italia/dist/svg/sprite.svg#it-close-circle"></use>
      </svg>
      <h1 class="title-xxxlarge">{{ 'pratica.payment_error' | trans }}</h1>
    </div>
    <p class="subtitle-small">{{ 'pratica.payment_error_message'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id,'%ente%':pratica.ente.name})|raw }}</p>
  {% else %}
    <div class="categoryicon-top d-flex">
      <svg class="icon icon-success mr-10 big-lg-icon mb-1" aria-hidden="true">
        <use href="/bootstrap-italia/dist/svg/sprite.svg#it-check-circle"></use>
      </svg>
      <h1 class="title-xxxlarge">{{ 'pratica.payment_success' | trans }}</h1>
    </div>
    <p class="subtitle-small">{{ 'pratica.thanks_message'|trans({'%name%':pratica.servizio.name,'%id%':pratica.id,'%ente%':pratica.ente.name})|raw }}</p>

    {% if not pratica.servizio.disableMessageNotifications %}
      <p class="pb-2 mb-0">{{ 'pratica.sent_to_email' | trans }}:<br>
        <strong>{{ pratica.user.email }}</strong>
      </p>
    {% endif %}
  {% endif %}

  <p class="mt-4 mb-0">{{ 'payment.amount' | trans }}: <strong>{{ pratica.paymentAmount }} € {{ 'pratica.payment_transaction_label'|trans }}</strong></p>
</div>